﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Threading;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        ObservableCollection<EntityViewModel> col;
        DispatcherTimer timer;
        Random r;

        public Window1()
        {
            InitializeComponent();

            this.xamDataGrid1.FieldLayoutSettings.SelectionTypeRecord 
                = Infragistics.Windows.Controls.SelectionType.Single;

            if(this.xamDataGrid1.Records[3] != null)
                this.xamDataGrid1.Records[3].IsSelected = true;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            r = new Random();

            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(1);
            timer.Tick += new EventHandler(timer_Tick);
            timer.IsEnabled = true;
            timer.Start();
        }

        protected override void OnInitialized(EventArgs e)
        {
            base.OnInitialized(e);
            
            col = new ObservableCollection<EntityViewModel>();

            for (int i = 0; i < 5; i++)
            {
                //model
                Entity ent = new Entity() { Field1 = i, Field2 = i, Field3 = i, Date = DateTime.Today.AddDays((double)i * -1) };

                //view-model
                EntityViewModel model = new EntityViewModel(ent);

                col.Add(model);
            }

            this.xamDataGrid1.DataSource = col;
        }

        //just to simulate updates to the underlying view model.
        void timer_Tick(object sender, EventArgs e)
        {
            int recordIndex = r.Next(0, col.Count);
            int fieldIndex = r.Next(0, 3);

            switch (fieldIndex)
            {
                case 0:
                    col[recordIndex].Field1 = r.Next();
                    break;
                case 1:
                    col[recordIndex].Field2 = r.Next();
                    break;
                case 2:
                    col[recordIndex].Field3 = r.Next();
                    break;
            }
            
        }
    }
}
